// -------------------------------------------------------------------------------------
//
// FishFace40.H                                                   Ulrich Mller 28.04.06
//                                                                PCS1700       VC++ 6.0
// H-File zu den Klassen CFishFace ... in FishFace40.CPP
//
// -------------------------------------------------------------------------------------

#ifndef _FishFace40_H_
#define _FishFace40_H_

#include <Windows.h>

// --------- enums, const, typedefs  ----------------------------------------------------

const int rbError = 0xE0000001L, rbFehler = rbError;

enum IFTypen {ftROBO_first_USB       = 0,  ftIntelligent_IF    = 10,
							ftIntelligent_IF_Slave = 20, ftROBO_IF_IIM       = 50,
							ftROBO_IF_USB          = 60, ftROBO_IF_COM       = 70,
							ftROBO_IF_Over_RF      = 80, ftROBO_IO_Extension = 90,
							ftROBO_RF_Datalink     = 110};
enum Port {portCOM1 = 1, portCOM2 = 2, portCOM3 = 3, portCOM4 = 4};

enum Dir  {dirLeft  = 1, dirRight  = 2, dirOff = 0, dirOn  = 1,
					 dirLinks = 1, dirRechts = 2, dirAus = 0, dirEin = 1};
enum Inp {anaAX  = 1,  anaAY  = 2,  anaAXS1 = 3, anaAXS2 = 4, anaAXS3 = 5,
					volA1  = 1,  volA2  = 2,  volAV   = 3, volAZ   = 4,
					disD1  = 1,  disD2  = 2,
					inpI1  = 1,  inpI2  = 2,  inpI3  = 3,  inpI4  = 4,  
					inpI5  = 5,  inpI6  = 6,  inpI7  = 7,  inpI8  = 8,
					inpI9  = 9,  inpI10 = 10, inpI11 = 11, inpI12 = 12, 
					inpI13 = 13, inpI14 = 14, inpI15 = 15, inpI16 = 16,
					inpI17 = 17, inpI18 = 18, inpI19 = 19, inpI20 = 20, 
					inpI21 = 21, inpI22 = 22, inpI23 = 23, inpI24 = 24,
					inpI25 = 25, inpI26 = 26, inpI27 = 27, inpI28 = 28, 
					inpI29 = 29, inpI30 = 30, inpI31 = 31, inpI32 = 32};
enum Out {outM1  = 1,  outM2  = 2,  outM3  = 3,  outM4  = 4,  
					outM5  = 5,  outM6  = 6,  outM7  = 7,  outM8 = 8,
					outM9  = 9,  outM10 = 10, outM11 = 11, outM12 = 12, 
					outM13 = 13, outM14 = 14, outM15 = 15, outM16 = 16,
					outO1  = 1,  outO2  = 2,  outO3  = 3,  outO4  = 4,  
					outO5  = 5,  outO6  = 6,  outO7  = 7,  outO8  = 8,
					outO9  = 9,  outO10 = 10, outO11 = 11, outO12 = 12, 
					outO13 = 13, outO14 = 14, outO15 = 15, outO16 = 16,
					outO17 = 17, outO18 = 18, outO19 = 19, outO20 = 20, 
					outO21 = 21, outO22 = 22, outO23 = 23, outO24 = 24,
					outO25 = 25, outO26 = 26, outO27 = 27, outO28 = 28, 
					outO29 = 29, outO30 = 30, outO31 = 31, outO32 = 32};

enum IRCode {ircAll = 0, ircCode1 = 1, ircCode2 = 2};
enum IRKeys {irkM3R  = 1, irkM3L  = 2, irkM1  = 3, irkM2  = 4,  irkM3    = 5, irkCode2 = 6, 
             irkM1BW = 7, irkM1FW = 8, irkM2L = 9, irkM2R = 10, irkCode1 = 11};
enum Speed{speNome = 0, speHalf = 7, speFull = 15};
enum Wait {waiEnd = 0,  waiTime = 1, waiNotHalt = 2, waiESC = 3};

typedef struct {
	BYTE   HwId;
	BYTE   SubId;
	USHORT MsgId;
	USHORT Msg;
} MessageData;
typedef struct {
	LPCSTR Name;
	int    Type;
	int    SerialNr;
	LPCSTR Firmware;
} DeviceData;

// ----- class CFishFaceException  ----------------------------------------------------------

class CFishFaceException {
private:
	int   aNr;
	char* aText;
public:
	CFishFaceException(int nr, char* text);
	char* Text() const;
	int   Nr() const;
};

inline char* CFishFaceException::Text() const {return aText;}
inline int   CFishFaceException::Nr()   const {return aNr;}

// --- umFish40.DLL Deklarationen ---------------------------
int __stdcall rbOpenInterfaceUSB(int ifTyp, int SerialNr);
int __stdcall rbOpenInterfaceRF(int IFSpez);
int __stdcall rbOpenInterfaceCOM(int ifTyp, int ComNr, int AnalogZyklen);
int __stdcall rbCloseInterface(int iHandle);

int __stdcall rbGetInput(int iHandle, int InputNr);
int __stdcall rbGetInputs(int iHandle);
int __stdcall rbGetAnalog(int iHandle, int AnalogNr);
int __stdcall rbGetIRKey(int Handle, int Code, int KeyNr);
int __stdcall rbGetVoltage(int iHandle, int VoltNr);

int __stdcall rbSetMotor(int iHandle, int MotNr, int Dir);
int __stdcall rbSetMotorEx(int iHandle, int MotNr, int Dir, int Speed);
int __stdcall rbGetMotors(int iHandle);
int __stdcall rbSetMotors(int iHandle, int MotorStatus);
int __stdcall rbSetMotorsEx(int iHandle, int MotorStatus, 
    												int SpeedStatus, int SpeedStatus16);
int __stdcall rbGetModeStatus(int iHandle, int MotNr);
int __stdcall rbSetModeStatus(int iHandle, int MotNr, int Mode);
int __stdcall rbSetLamp(int iHandle, int LampNr, int OnOff);
int __stdcall rbSetLampEx(int iHandle, int LampNr, int OnOff, int Power);
int __stdcall rbRobMotor(int iHandle, int MotNr, int Dir, int Speed, int ICount);
int __stdcall rbRobMotors(int iHandle, int MotorStatus, 
													int SpeedStatus, int SpeedStatus16, int ModeStatus);

int __stdcall rbGetCounter(int iHandle, int CounterNr);
int __stdcall rbSetCounter(int iHandle, int CounterNr, int ICount);
int __stdcall rbClearCounters(int iHandle);

int __stdcall rbClearMessagesIn(int Handle);
int __stdcall rbClearMessagesOut(int iHandle);
int __stdcall rbGetMessage(int iHandle, MessageData* inN);
int __stdcall rbIsMessage(int iHandle);
int __stdcall rbSendMessage(int iHandle, MessageData* outN);
int __stdcall rbSendMessageEx(int iHandle, MessageData* outN, int Spez);

int    __stdcall rbGetActDeviceType(int iHandle);
int    __stdcall rbGetActDeviceSerialNr(int iHandle);
int    __stdcall rbGetActDeviceFirmwareNr(int iHandle);
LPCSTR __stdcall rbGetActDeviceFirmware(int iHandle);
LPCSTR __stdcall rbGetActDeviceName(int iHandle);

// ------- class CFishFace -------------------------------------------------------------------

class CFishFace {
private:
	int  iHandle;
	int  aPortNr;
	bool aOpen;
	bool aNotHalt;
	int  aPollInterval;
	int  aAnalogScan;

public:
	CFishFace();
	~CFishFace();

	DeviceData ActDevice();
	void ClearCounter(int InputNr) {rbSetCounter(iHandle, InputNr, 0);};
	void ClearCounters() {rbClearCounters(iHandle);};
	void ClearMessagesIn();
	void ClearMessagesOut();
	void ClearMotors();
	void CloseInterface();
	bool Finish();
	bool Finish(int InputNr);
	bool Finish(int IRCode, int IRKey);
	int  GetAnalog(int AnalogNr);
	int  GetCounter(int InputNr) {return rbGetCounter(iHandle, InputNr);};
	bool GetInput(int InputNr);
	int  GetInputs();
	bool GetIRKey(int IRCode, int IRKey);
	MessageData GetRFMessage();
	int GetVoltage(int VoltNr);
	bool IsRFMessage();
	bool NotHalt() const {return aNotHalt;};
	void NotHalt(bool value) {aNotHalt = value;};
	void OpenInterface(int IFSpez);
	void OpenInterface(int IFTyp, int IFSpez);
	void OpenInterface(int IFTyp, int IFSpez, int AnalogZyklen);
	int  Outputs() {rbGetMotors(iHandle);};
	void Outputs(int value) {rbSetMotors(iHandle, value);};
	void Pause(unsigned int mSek);
	void SendRFMessage(MessageData mData);
	void SendRFMessage(MessageData mData, int Spez);
	void SetCounter(int InputNr, int value) {rbSetCounter(iHandle, InputNr, value);};
	void SetLamp(int LampNr, int OnOff);
	void SetLamp(int LampNr, int OnOff, int Power);
	void SetMotor(int MotorNr, int Direction);
	void SetMotor(int MotorNr, int Direction, int Speed);
	void SetMotor(int MotorNr, int Direction, int Speed, int Counter);
	void SetMotors(int MotorStatus);
	void SetMotors(int MotorStatus, int SpeedStatus, int SpeedStatus16);
	void SetMotors(int MotorStatus, int SpeedStatus, int SpeedStatus16, int ModeStatus);
	char* Version() const  {return "4.1.59.1";};
	void WaitForChange(int InputNr, int NrOfChanges, int TermInputNr = 0);
	void WaitForHigh(int InputNr);
	void WaitForInput(int InputNr, bool OnOff = true);
	void WaitForInput(int IRCode, int IRKeyNr, bool OnOff = true);
	void WaitForLow(int InputNr);
	int  WaitForRFMessage(int mSek, MessageData mData); 
	int  WaitForMotors(unsigned int mSek, int M1, int M2 = 0, int M3 = 0, int M4 = 0,
															int M5 = 0, int M6 = 0, int M7 = 0, int M8 = 0);
	int  WaitForPositionDown(int InputNr, int Counter, int Position, int TermInputNr = 0);
	int  WaitForPositionUp(int InputNr, int Counter, int Position, int TermInputNr = 0);
	void WaitForTime(unsigned int mSek);
};

#endif
