// -------------------------------------------------------------------------------
//
// HelloFish.CPP                                           Ulrich Mller  03.05.06
//                                                         PCS1700        VC++ 6.0
// Sample program VC++ (Console) for umFish40.DLL
// Lamps on  M1, M2, M3, Endswitch I1 and Photoresitor on AX (optional)
// with ROBO Interface on USB
//
// ------------------------------------------------------------------------------

#include <windows.h>
#include <iostream.h>
#include "..\umFish40VC.h"

void main()
{
	char END;
	cout << "---- HelloFish started ----" << endl;
		
	// --- Connection to the interface --------------------------------------------------
	int iHandle = rbOpenInterfaceUSB(0, 0);      // -- first Interface on USB
	if(iHandle == rbFehler) {                    //    on Error : Exit
		cout << "Interface Problem, exit" << endl;
  	cout << endl << "--- FINIS : Return Key ---" << endl;
  	cin.get(END);
		return;
	}
	cout << "Interface : " << rbGetActDeviceName(iHandle)
		   << ", Type : " << rbGetActDeviceType(iHandle)
			 << ", SerialNr : " << rbGetActDeviceSerialNr(iHandle) << endl;
	cout << "Firmware  : " << rbGetActDeviceFirmware(iHandle) << endl;


	cout << "--- Loop for the three lamps on M1 to M3" << endl;
	for(int j=1; j<=4; j++) {
		cout << "Round : " << j << endl;
		rbSetMotors(iHandle, 0);         // --- all Motors off
		Sleep(300);                      // --- 0.3 sec Pause 
		for(int i=1; i<=3; i++) {
			rbSetMotor(iHandle, i, 1);     // --- switch on Lamp on Mi
			Sleep (500);
		}
	}
  
	// --------------------------------- End -----------------------------------
  rbCloseInterface(iHandle);            // --- Cut connection to the interface
	cout << endl << "--- FINIS : Return Key ---" << endl;
	cin.get(END);
}

