// -------------------------------------------------------------------------------------
//
// FunkRaupe4.CPP                                                 Ulrich Mller 02.05.06
//                                                                PCS1700       VC++ 6.0
// Steuerung einer Raupe RF2/2 durch ein Interface RF 2/1 ber
// ber ein PC-Programm via RF Datalink RF2/0
// Basis ist die Klasse CFishFace / umFish40.DLL v4.1.59.1
// Die Raupe hat ein Renesas C Betriebsprogramm geladen.
// RF 2/1 wird als Fernsteuerung eingesetzt, dazu ist sie mit vier Tastern an I1 - I4
// ausgerstet und zustzlich je einer roten und grnen Lampe an O2 / O1
// RF 2/2 wartet in einer Endlosscleife auf Nachrichten, die Fahrbefehle enthalten
// und fhrt diese aus.
//
// -------------------------------------------------------------------------------------

#include <windows.h>
#include <iostream.h>
#include <string>
#include "..\FishFace40.h"

const USHORT cVor    = 0x0A00;
const USHORT cRueck  = 0x0500;
const USHORT cLinks  = 0x0900;
const USHORT cRechts = 0x0600;
const USHORT cAus    = 0x0000;

CFishFace ft;


void main() {
	cout << "--- FunkRaupe4 gestartet ---" <<  endl;
	cout << "To end : ESC Key" << endl;

	try {
		ft.OpenInterface(ftROBO_first_USB, 0);

		MessageData outN;
		outN.HwId  = 2;
		outN.SubId = 1;
		outN.MsgId = 0x01;
		outN.Msg   = cAus;
		ft.SetLamp(outO1, dirEin);
		cout << "Ready, waiting for your orders : I1 .. I4" << endl;
		do {
			if(ft.GetInputs() != 0) {
				if     (ft.GetInput(inpI1)) outN.Msg = outN.Msg == cVor    ? cAus : cVor;
				else if(ft.GetInput(inpI2)) outN.Msg = outN.Msg == cLinks  ? cAus : cLinks;
				else if(ft.GetInput(inpI3)) outN.Msg = outN.Msg == cRechts ? cAus : cRechts;
				else if(ft.GetInput(inpI4)) outN.Msg = outN.Msg == cRueck  ? cAus : cRueck;
				ft.SendRFMessage(outN);
				if(outN.Msg != cAus) {
					ft.SetLamp(outO1, dirAus);
					ft.SetLamp(outO2, dirEin);
					cout << "--- Busy ---" << endl;
				}
				else {
					ft.SetLamp(outO1, dirEin);
					ft.SetLamp(outO2, dirAus);
					cout << "--- Ready ---" << endl;
				}
			}
			ft.Pause(555);
		} while(!ft.Finish());
		ft.CloseInterface();
	}
	catch(CFishFaceException& fte) {
		cout << "Error " << fte.Nr() << " : " << fte.Text() << endl;
	}
}